﻿@using DocumentFormat.OpenXml.Wordprocessing
@{
    ViewBag.Title = "Application Parameter";
    Layout = "~/Views/Shared/_FixedLayout.cshtml";
}

<link href="~/Content/plugins/datatables/css/dataTables.bootstrap.css" rel="stylesheet" />
<script src="~/Content/plugins/datatables/js/jquery.dataTables.min.js"></script>
<script src="~/Content/plugins/datatables/js/jquery.dataTables.columnFilter.js"></script>
<script src="~/Content/plugins/datatables/js/dataTables.bootstrap.js"></script>


<script type="text/javascript">

    var oTable;


    $(document).ready(function () {
        void function loadGroupParam() {
            var GetDetail = '@Url.Action("getGroupAppParamDetail", "ApplicationParameter", new { rowid = @ViewBag.RowId })';
            $.ajax(GetDetail, {
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                type: 'POST',
                success: function (GetDetail) {
                    if (GetDetail.success) {
                        document.getElementById("txtGroupName").value = GetDetail.groupname;
                        document.getElementById("txtDescription").value = GetDetail.description;
                    }
                },
                error: function () {

                }
            });
        }
        ();

        void function loadParamList() {

            var aryColTableChecked = [];
            for (var idx = 1; idx < 5; idx++) {
                aryColTableChecked.push("field" + idx);
            }

            var aoColumnDef = [];

            $.each(aryColTableChecked, function (i, value) {

                var obj = {
                    "mData": value,
                    "aTargets": [i]
                }
                if (i == 0) {
                    var obj = {
                        "mData": value,
                        "aTargets": [i],
                        "mRender": function (data, type, row) {
                            return '<a class="btn btn-primary btn-xs tblButton" style="width: 30px;" name="btnEdit" aria-label="Edit" data-id="' + data + '" ><i class="glyphicon glyphicon-pencil"></i></a>' +
                            '&nbsp; <a class="btn btn-primary btn-xs tblButton" style="width: 30px;" name = "btnDelete" aria-label="Delete" data-id="' + data + '" ><i class="glyphicon glyphicon-trash"></i></a>';

                        },
                        "bSortable": false
                    }
                }
                aoColumnDef.push(obj);
            });

            if (oTable != null) {
                oTable.fnDestroy();
            }

            oTable = $('#tblData').dataTable({
                "sAjaxSource": "@Url.Action("getAppParamList", "ApplicationParameter")",
                "bServerSide": false,
                "bProcessing": true,
                "bSort": false,
                "bPaginate": true,
                "bLengthChange": false,
                "bStateSave": false,
                "bDestroy": true,
                "bRetrieve": true,
                "fnServerData": function (sSource, aoData, fnCallback) {
                    $.ajax({
                        "dataType": "json",
                        "type": "POST",
                        "url": sSource,
                        "data": aoData,
                        "success": fnCallback
                    });
                },
                "sDom": '<"#tblData_header.clearfix "<"pull-left"l><"pull-right"r>><"table-responsive"t><"#ScrollTop"><"#tblData_footer.clearfix "<"pull-left"i><"pull-right"p>>',
                "fnServerParams": function (aoData) {
                    aoData.push({ "name": "rowid", "value": '@ViewBag.RowId' });
                },
                "aoColumnDefs": aoColumnDef,
                "iDisplayLength": 10,
                "oLanguage": {
                    "sProcessing": '<i class="fa fa-spinner fa-spin"></i> Retrieve Data ... ',
                    "sLengthMenu": '_MENU_'
                },
            });

            oTable.fnSettings().aoColumns[0].sClass = "text-center";
            oTable.fnSettings().aoColumns[1].sClass = "text-center";
            oTable.fnSettings().aoColumns[2].sClass = "text-center";
            oTable.fnSettings().aoColumns[3].sClass = "text-center";
            
            $('#tblData tbody').on('click', 'a', function () {

                var table = $('#tblData').DataTable();
                var row = table.row($(this).parents('tr')).data();
                var action = $(this).attr('aria-label');
                var rowid = $(this).attr('data-id');

                if (action == 'Edit') {
                    window.location.href = '@Url.Action("EditParameter", "ApplicationParameter")?id=' + rowid + '&groupid=' + '@ViewBag.RowId';
                }

                if (action == 'Delete') {
                    bootbox.confirm({
                        title: "<i class='fa fa-warning fa-2x'></i> Delete Confirmation",
                        message: 'Are you sure you want to delete this data.',
                        className: "medium",
                        buttons: {
                            'cancel': {
                                label: '<i class="fa fa-times"></i> Cancel',
                                className: 'btn-default pull-left'
                            },
                            'confirm': {
                                label: '<i class="fa fa-check"></i> Yes, Continue delete',
                                className: 'btn-primary pull-right'
                            }
                        },
                        callback: function (result) {
                            if (result) {
                                
                                $.ajax({
                                    type: "POST",
                                    url: '@Url.Action("DeleteParam", "ApplicationParameter")?rowid=' + rowid + '&groupid=' + '@ViewBag.RowId',
                                    dataType: 'json',
                                    contentType: false,
                                    processData: false,
                                    //beforeSend: function () {
                                    //    //$("#loader").show();
                                    //},
                                    success: function (data) {
                                        bootbox.dialog({
                                            message: data.message,
                                            title: data.title,
                                            buttons: {
                                                main: {
                                                    label: "<i class='fa fa-check'></i> Ok",
                                                    className: "btn-primary",
                                                    callback: function () {
                                                        if (result) {
                                                            if (data.status) {
                                                                oTable.fnPageChange('first');
                                                                window.location.href = '@Url.Action("BackApplicationParameter", "ApplicationParameter")?id='+'@ViewBag.RowId';
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    });
                                }
                            });
                        }

                    }
                    });
            }


            });
    }();

    $("#btnSave").click(function () {
        //validation
        if ($('#txtGroupName').val().length == 0) {
            bootbox.alert("<i class='fa fa-warning fa-2x'></i> Please fill mandatory field (<label class='required'></label>)", function () {
                setTimeout(function () { }, 500);
            });
        } else {

            //confirmation
            bootbox.confirm({
                title: "<i class='fa fa-warning fa-2x'></i> Save Confirmation",
                message: 'Are you sure you want to save this data. <br>If not, click Cancel',
                buttons: {
                    'cancel': {
                        label: '<i class="fa fa-times"></i> Cancel',
                        className: 'btn-default pull-left'
                    },
                    'confirm': {
                        label: '<i class="fa fa-check"></i> Yes, Continue save',
                        className: 'btn-primary pull-right'
                    }
                },
                callback: function (result) {
                    if (result) {
                        var GroupParamList = [
                             {
                                 id:'@ViewBag.RowId',
                                 groupname: $('#txtGroupName').val(),
                                 description: $('#txtDescription').val()

                             }
                        ];

                        GroupParamList.push();

                        var formData = new FormData();
                        formData.append("GroupParamList", JSON.stringify(GroupParamList));


                        //Save Process
                        $.ajax({
                            type: "POST",
                            url: '@Url.Action("SaveGroupParam", "ApplicationParameter")',
                            data: formData,
                            dataType: 'json',
                            contentType: false,
                            processData: false,
                            //beforeSend: function () {
                            //    //$("#loader").show();
                            //},
                            success: function (data) {
                                bootbox.dialog({
                                    message: data.message,
                                    title: data.title,
                                    buttons: {
                                        main: {
                                            label: "<i class='fa fa-check'></i> Ok",
                                            className: "btn-primary",
                                            callback: function () {
                                                if (result) {
                                                    if (data.status) {
                                                        window.location.href = '@Url.Action("ApplicationParameter", "ApplicationParameter")';
                                                    }
                                                }
                                            }
                                        }
                                    }
                                });
                            }
                        });

                    }
                }
            });
        }


    });
    });


</script>

<style>
    .label-def-margin {
        margin-top: 6px;
    }

    .required:after {
        content: "*";
        color: red;
    }
</style>


<div class="col-sm-12">
    <div class="panel panel-primary" style="margin-bottom: 0;">
        <div class="panel-heading">
            Edit Application Parameter Group

        </div>
        <div class="panel-body">

            <!--Group Name-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtGroupName">Group Name</label></div>
                <div class="col-sm-4"><input class="form-control" type="text" id="txtGroupName" /></div>
            </div>
            <!--Description-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtDescription">Description</label></div>
                <div class="col-sm-4"><input class="form-control" type="text" id="txtDescription" /></div>
            </div>

            <!--Add Param-->
            <div class="row">
                <div class="col-sm-3">
                    <button type="button" class="btn btn-primary" id="btnAddParam" name="btnAddParam" onclick="@("window.location.href='" + @Url.Action("AddParameter", "ApplicationParameter") + "?id='")+@ViewBag.RowId;">
                        <span class="glyphicon glyphicon-plus-sign"></span> Add Param
                    </button>
                </div>
            </div>

            <!--Menu List-->

            <table id="tblData" class="table table-striped table-hover table-bordered" width="100%" style="font-size: 10px; margin-top: 0 !important; margin-bottom: 0 !important; padding-top: 0 !important; padding-bottom: 0 !important;">
                <thead class="bg-mantle-gradient">
                    <tr>
                        <th style ="width: 80px;">Action &nbsp; </th>
                        <th>Param Name &nbsp; </th>
                        <th>Param Value &nbsp; </th>
                        <th>Description &nbsp; </th>
                    </tr>
                </thead>
            </table>

        </div>
        <div class="panel-footer">
            <div class="row">
                <div class="col-sm-12">
                    <button type="button" class="btn btn-primary" id="btnSave">
                        <span class="glyphicon glyphicon-floppy-disk"></span> Save
                    </button>
                    &nbsp;
                    <button type="button" class="btn btn-primary" onclick="@("window.location.href='" + @Url.Action("BackGroupApplicationParameter", "ApplicationParameter") + "'");">
                        <span class="glyphicon glyphicon-circle-arrow-left"></span> Back
                    </button>
                </div>
            </div>
        </div>



    </div>
</div>
